#extension GL_OES_EGL_image_external : require

precision mediump float;

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
varying highp vec2 textureCoordinate3;

uniform samplerExternalOES uTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform mediump float smoothDegree;   // 光滑程度

void main()
{
    highp vec4 bilateral = texture2D(uTexture, textureCoordinate);
    highp vec4 canny = texture2D(inputImageTexture2, textureCoordinate);
    highp vec4 origin = texture2D(inputImageTexture3,textureCoordinate);
    highp vec4 smooth;
    lowp float r = origin.r;
    lowp float g = origin.g;
    lowp float b = origin.b;
    if (canny.r < 0.2 && r > 0.3725 && g > 0.1568 && b > 0.0784 && r > b && (max(max(r, g), b) - min(min(r, g), b)) > 0.0588 && abs(r-g) > 0.0588) {
        smooth = (1.0 - smoothDegree) * (origin - bilateral) + bilateral;
    }
    else {
        smooth = origin;
    }
    smooth.r = log(1.0 + 0.2 * smooth.r)/log(1.2);
    smooth.g = log(1.0 + 0.2 * smooth.g)/log(1.2);
    smooth.b = log(1.0 + 0.2 * smooth.b)/log(1.2);
//    highp vec4 smooth;
//    smooth =bilateral = texture2D(uTexture, textureCoordinate);
    gl_FragColor = smooth;
}